clang 10.0.0git

Public Types | Public Member Functions | List of all members
clang::analyze_format_string::OptionalAmount Class Reference

`#include "clang/AST/FormatString.h"`

## Public Types
enum | HowSpecified { NotSpecified, Constant, Arg, Invalid }

## Public Member Functions
| OptionalAmount (HowSpecified howSpecified, unsigned amount, const char *amountStart, unsigned amountLength, bool usesPositionalArg)
| OptionalAmount (bool valid=true)
| OptionalAmount (unsigned Amount)
bool | isInvalid () const
HowSpecified | getHowSpecified () const
void | setHowSpecified (HowSpecified h)
bool | hasDataArgument () const
unsigned | getArgIndex () const
unsigned | getConstantAmount () const
const char * | getStart () const
unsigned | getConstantLength () const
ArgType | getArgType (ASTContext &Ctx) const
void | toString (raw_ostream &os) const
bool | usesPositionalArg () const
unsigned | getPositionalArgIndex () const
bool | usesDotPrefix () const
void | setUsesDotPrefix ()

## Detailed Description

Definition at line 325 of file FormatString.h.

## Member Enumeration Documentation

## ◆ HowSpecified

enum clang::analyze_format_string::OptionalAmount::HowSpecified

Enumerator
NotSpecified |
Constant |
Arg |
Invalid |

Definition at line 327 of file FormatString.h.

## Constructor & Destructor Documentation

## ◆ OptionalAmount() [1/3]

clang::analyze_format_string::OptionalAmount::OptionalAmount | ( | HowSpecified | howSpecified,
|  | unsigned | amount,
|  | const char * | amountStart,
|  | unsigned | amountLength,
|  | bool | usesPositionalArg
| ) |  |
| inline

Definition at line 329 of file FormatString.h.

## ◆ OptionalAmount() [2/3]

clang::analyze_format_string::OptionalAmount::OptionalAmount | ( | bool | valid = `true` | ) |
| inline

Definition at line 337 of file FormatString.h.

## ◆ OptionalAmount() [3/3]

clang::analyze_format_string::OptionalAmount::OptionalAmount | ( | unsigned | Amount | ) |
| inline explicit

Definition at line 341 of file FormatString.h.

## Member Function Documentation

## ◆ getArgIndex()

unsigned clang::analyze_format_string::OptionalAmount::getArgIndex | ( |  | ) | const
| inline

Definition at line 354 of file FormatString.h.

## ◆ getArgType()

ArgType analyze_format_string::OptionalAmount::getArgType | ( | ASTContext & | Ctx | ) | const

Definition at line 568 of file FormatString.cpp.

References clang::ASTContext::IntTy.

## ◆ getConstantAmount()

unsigned clang::analyze_format_string::OptionalAmount::getConstantAmount | ( |  | ) | const
| inline

Definition at line 359 of file FormatString.h.

Referenced by clang::analyze_format_string::ParsePositionAmount().

## ◆ getConstantLength()

unsigned clang::analyze_format_string::OptionalAmount::getConstantLength | ( |  | ) | const
| inline

Definition at line 369 of file FormatString.h.

References length(), and clang::analyze_format_string::OptionalFlag::toString().

## ◆ getHowSpecified()

HowSpecified clang::analyze_format_string::OptionalAmount::getHowSpecified | ( |  | ) | const
| inline

Definition at line 349 of file FormatString.h.

Referenced by clang::analyze_format_string::ParsePositionAmount().

## ◆ getPositionalArgIndex()

unsigned clang::analyze_format_string::OptionalAmount::getPositionalArgIndex | ( |  | ) | const
| inline

Definition at line 379 of file FormatString.h.

Referenced by toString().

## ◆ getStart()

const char* clang::analyze_format_string::OptionalAmount::getStart | ( |  | ) | const
| inline

Definition at line 364 of file FormatString.h.

## ◆ hasDataArgument()

bool clang::analyze_format_string::OptionalAmount::hasDataArgument | ( |  | ) | const
| inline

Definition at line 352 of file FormatString.h.

## ◆ isInvalid()

bool clang::analyze_format_string::OptionalAmount::isInvalid | ( |  | ) | const
| inline

Definition at line 345 of file FormatString.h.

Referenced by clang::analyze_format_string::ParseFieldWidth().

## ◆ setHowSpecified()

void clang::analyze_format_string::OptionalAmount::setHowSpecified | ( | HowSpecified | h | ) |
| inline

Definition at line 350 of file FormatString.h.

## ◆ setUsesDotPrefix()

void clang::analyze_format_string::OptionalAmount::setUsesDotPrefix | ( |  | ) |
| inline

Definition at line 385 of file FormatString.h.

References length().

Referenced by clang::analyze_printf::PrintfSpecifier::setPrecision().

## ◆ toString()

void OptionalAmount::toString | ( | raw_ostream & | os | ) | const

Definition at line 699 of file FormatString.cpp.

References Arg, Constant, getPositionalArgIndex(), Invalid, NotSpecified, and usesPositionalArg().

## ◆ usesDotPrefix()

bool clang::analyze_format_string::OptionalAmount::usesDotPrefix | ( |  | ) | const
| inline

Definition at line 384 of file FormatString.h.

## ◆ usesPositionalArg()

bool clang::analyze_format_string::OptionalAmount::usesPositionalArg | ( |  | ) | const
| inline

Definition at line 378 of file FormatString.h.

Referenced by toString().

The documentation for this class was generated from the following files:

- include/clang/AST/FormatString.h
- lib/AST/FormatString.cpp